/////////////////////////////////////////
// Asteroid game maths interface.
//
// Version: 101011_01
/////////////////////////////////////////

#ifndef _ASTMATHS_H_
#define _ASTMATHS_H_

#include <math.h>

//Debug
#include <iostream>
using namespace std;

#define M_PI 3.14159265358979323846

//Note: The collision check can still fail sometimes if the ship and the asteroid collide in the middle area of the screen.
//Fix this this asap.

////////////////////////////////////////////////////////////////////////////////////////////////////
//Sphere based collision checking between two moving objects.
//The expenisve calculations are only carried ut if both objects are in the same screen region.
////////////////////////////////////////////////////////////////////////////////////////////////////
bool CollisionCheck(int x1, int y1, int radis1, int x2, int y2, int radis2)
{
	bool canCollide;
	int xd, yd, distance;

	//////////////////////////////////////////////////////////////////////////////
	//First, make sure that the asteroid and the ship are cloase to each other
	//////////////////////////////////////////////////////////////////////////////

	//Note: There is a logic error with this code, as the Y coordinate value for the MOVING asteroid is always 10.
	//This has been fixed with a quick hack where the y coordinate value of the asteroid is the x coordinate value.
	//Since the asteroids move in a straight diagonal line, this hack is simply an implementation of the the
	//elementary y = mx + c line equation. 

	//Top left
	if((x1 < 25 && x2 < 25) && ((y1 < 50 && y1 > 25) && (y2 < 50 && y2 > 25)))
	{
		//cout << "Both collision objects in top left corner" << endl;
		canCollide = true;

	}
	//Top right
	else if((x1 > 25 && x2 > 25) && ((y1 < 50 && y1 > 25) && (y2 < 50 && y2 > 25)))
	{
		//cout << "Both collision objects in top right corner" << endl;
		canCollide = true;
	}
	//bottom left
	else if((x1 < 25 && x2 < 25) && ((y1 > 0 && y1 < 25) && (y2 > 0 && y2 < 25)))
	{
		//cout << "Both collision objects in bottom left corner" << endl;
		canCollide = true;
	}
	//bottom right
	else if((x1 > 25 && x2 > 25) && ((y1 > 0 && y1 < 25) && (y2 > 0 && y2 < 25)))
	{
		//cout << "Both collision objects in bottom right corner" << endl;
		canCollide = true;
	}
	else
	{
		//cout << "Collision objects not in the same screen region" << endl;
		canCollide = false;
	}

	//debug

	/*cout << "x1: " << x1 << endl;
	cout << "x2: " << x2 << endl;
	cout << "y1: " << y1 << endl;
	cout << "y2: " << y2 << endl;
	cout << "radis1: " << radis1 << endl;
	cout << "radis2: " << radis2 << endl;
	system("CLS");*/

	if(canCollide)
	{
		xd = x2-x1; //use abs() is needed
		yd = y2-y1;    
		distance = (int)sqrt(((double)xd*xd) + ((double)yd*yd));

		//cout << "xd: " << xd << endl;
		//cout << "yd: " << yd << endl;
		//cout << "distance: " << distance << endl;

		if(radis1 + radis2 >= distance)
		{
			return true; //collision
		}
	}

    return false;    //no collision    
}

#endif

